#!/bin/bash

echo Update linux kernel from kernel.org Mercurial repository
# mkdir -p ~/linux/hg
# hg clone http://kernel.org/hg/linux-2.6
cd ~/linux/hg/linux-2.6
hg pull -u

echo Install updated Documentation
rm -rf ~/www/kdocs/Documentation/
cp -a ~/linux/hg/linux-2.6/Documentation ~/www/kdocs/Documentation

echo Build htmldocs and xhtml-nochunks
rm -rf ~/linux/temp
cd ~/linux/hg/linux-2.6
mkdir ~/linux/temp
make allnoconfig O=~/linux/temp

# I have a dual processor laptop, so overlap work here.  Generate the xml
# first, then have make htmldocs produce split-up versions in the background
# while a script produces nochunks versions in the foreground.
cd ~/linux/temp
make -j 2 xmldocs
make -j 2 htmldocs &
cd Documentation/DocBook
for i in *.xml
do
  echo "Converting $i"
  xmlto xhtml-nochunks $i -o xhtml-nochunks 
done
# Wait for background task to finish before retrieving result
while [ $(jobs | wc -l) -ne 0 ]
do
  sleep 1
  # Without this next line, bash never notices a change in the number of jobs.
  # Bug noticed in Ubuntu 7.04
  jobs > /dev/null
done
mv xhtml-nochunks/*.html .
rmdir xhtml-nochunks

echo Install htmldocs
rm -rf ~/www/kdocs/htmldocs
cp -a ~/linux/temp/Documentation/DocBook ~/www/kdocs/htmldocs
echo "Done with kdocs"
